; TIP1129.LSP: DDTXT.LSP   Edit Multiple Text Lines   (c)1995, Shaun Seela

(defun clean_up ()
   (setq *error* OLDERR)
   (setq TXT_LST nil LST_NUM nil NUM nil PAG_LST nil LN nil
      F_LST nil CNT nil FINISH nil TMP nil NN nil LEN nil
      KEY nil CNT2 nil FLD nil
   )
)
;;; Fills the edit boxes with an item from string list
;;; each time the next or previous button is selected
(defun next_prev ( LST NUM KEY / ITEM TEXT CNT)
   (mode_tile "edit_1" 2)
   (if (= KEY nil)(setq KEY "next"))
   (if (= KEY "next")(setq LST_NUM (1+ LST_NUM))(setq LST_NUM (- LST_NUM 1)))
   (if (= LST_NUM 0)(PROGN
         (mode_tile "prev" 1)
      )
      (mode_tile "prev" 0)
   )
   (if (= KEY "next")
      (if (= LST_NUM (1- (length PAG_LST)))(mode_tile "next" 1))
      (if (= LST_NUM (1- (length PAG_LST)))(mode_tile "next" 1)(mode_tile "next" 0))
   )       
   ;;; Blank out edit fields
   (setq CNT 0)
   (while (< CNT (1+ NUM))  
      (setq ITEM (strcat "prompt_" (itoa (1+ CNT))))
      (setq TEXT (strcat "edit_" (itoa (1+ CNT))))
      (set_tile ITEM "")
      (set_tile TEXT "")
      (mode_tile TEXT 1)
      (setq CNT (1+ CNT))
   )
   ;;; Fill edit fields
   (setq LEN (length (nth LST_NUM PAG_LST))) 
   (setq CNT 0)
   (while (< CNT LEN)
      (setq ITEM (strcat "prompt_" (itoa (1+ CNT))))
      (setq TEXT (strcat "edit_" (itoa (1+ CNT))))
      (set_tile ITEM (strcat "Item " (itoa (+ (+ CNT 1) (* LST_NUM NUM))) ":"))
      (mode_tile TEXT 0)
      (set_tile TEXT (cdr (nth CNT (NTH LST_NUM LST))))
      (setq CNT (1+ CNT))
   )
   (set_tile "pageof" (strcat (itoa (1+ LST_NUM)) " of " (itoa (length PAG_LST))))
)
;;; Saves each pages changes back to pag_lst
(defun sav_chgs ( KEY / KEY)
   (setq LEN (length (nth LST_NUM PAG_LST))) 
   (setq CNT 0)
   (while (< CNT LEN)
      (setq FLD (get_tile (strcat "edit_" (itoa (1+ CNT)))))
      (setq PAG_LST (subst (subst (cons CNT FLD)
      (nth CNT (nth LST_NUM PAG_LST)) (nth LST_NUM PAG_LST)) (nth LST_NUM PAG_LST) PAG_LST))
      (setq CNT (1+ CNT))
   )
   (setq CNT 0)
   (if (= KEY "accept")(progn
         (setq CNT 0)
         (setq CNT2 0)
         (setq F_LST nil)
         (while (< CNT (length PAG_LST))
            (while (< CNT2 (length (nth CNT PAG_LST)))
               (setq F_LST (append F_LST (list (cons '1 (cdr (nth CNT2 (nth CNT PAG_LST)))))))
               (setq CNT2 (1+ CNT2))
            )
            (setq cnt (1+ cnt))
            (setq cnt2 0)
         )
         (setq finish 1)
      )
   )                    
)
;;; Creates a list of dotted pairs from the entity
;;; name argument for each text item found in the entity.
(defun get_tags (EN / EL ANS)
   (setq EL (entget EN))
   (setq ANS (cons (cons '1 (cdr (assoc 1 EL))) ANS))
   (reverse ANS)
)
;;; Takes a list of dotted pairs and applies
;;; the value associated with each tag to the entities attributes 
(defun put_tags (GT TLIST / EL)
   (setq CNT 0)
   (while (< CNT (length TLIST))
      (setq E (ssname GT CNT))
      (setq EL (entget E))       
      (entmod (subst (nth CNT TLIST) (assoc 1 EL) EL))
      (setq CNT (1+ CNT))
   )
)
;;; Reads the key selected so the focus of the edit box is
;;; changed each time the the RETURN key is pressed. The case changing
;;; is also checked here.
(defun read_val ( RES KEY CASE / NMBR) 
   (setq NMBR (atoi (substr KEY 6 (- (strlen KEY) 5))))
   (if (= RES 1)                   
      (progn
         (if (= NMBR NUM)
            (progn
               (if (/= (length PAG_LST) (1+ LST_NUM))(progn
                     (sav_chgs "next")
                     (next_prev PAG_LST NUM "next")
                     (mode_tile "edit_1" 2)
                  )
                  (mode_tile "edit_1" 2)
               )                                                     
               (if (/= CASE nil)(chg_case KEY CASE))
            )
         )
         (if (and (= (length (last PAG_LST)) NMBR)(= LST_NUM (1- (length PAG_LST))))(progn
               (mode_tile "edit_1" 2)
               (if (/= CASE nil)(chg_case KEY CASE))
            )
            (progn
               (if (/= CASE nil)(chg_case KEY CASE))
               (if (/= NMBR NUM)
                  (mode_tile (cadr (member KEY DCL_LST)) 2)
               (mode_tile "edit_1" 2))          
            )
         )
      )
   )
)
;;; Changes the case of selected text edit box
(defun chg_case ( KEY VAL / )
   (if (= VAL 1)
      (set_tile KEY (strcase (get_tile KEY)))
      (set_tile KEY (strcase (get_tile KEY) T ))
   )
)
;;; Cleans up if an error occurs
(defun *merr* (MSG)
   (princ (strcat "ERROR: " MSG))(clean_up)
   (princ)
) 
;;; The main defun that controls the entire program
(DEFUN C:DDTXT ( / TXT_LST NUM LN CNT LST_NUM PAG_LST F_LST FINISH TMP NN GT
   LN CNT E DIAL DCL_LST)
   (setq OLDERR *error*) (setq *error* *merr*)
   (setq TXT_LST nil
      PAG_LST nil
      DCL_LST nil
      TMP     nil 
      NN      0 
   finish  0)
   (setq GT (ssget '((0 . "TEXT"))))
   (setq LN (sslength gt))
   (setq LST_NUM -1)  ; keeps track of the position in the txt_lst
   (setq PAGES 0)    ; keeps track of the number of pages to fill up
   (setq DIAL (load_dialog "ddtxt"))  
   (new_dialog "ddtxt" dial)
   (setq NUM (atoi (get_attr "ddtxt_top" "number")))
   (set_tile "ddtxt_top" "DDTXT - Text Edit")
   ; Sets up a list of available edit tags based on the
   ; Variable num_items in the dcl file
   (setq CNT 1)                
   (while (< CNT (1+ NUM))
      (setq DCL_LSt (append dcl_lst (LIST (strcat "edit_" (ITOA CNT)))))
      (setq CNT (1+ CNT))
   )
   (setq CNT 0)
   (while (< CNT LN)    ;; creates the txt_lst
      (setq E (ssname GT CNT))
      (setq TXT_LST (append TXT_LST (list (cdr (assoc 1 (get_tags E))))))
      (setq tmp (append tmp (list (cons nn (cdr (assoc 1 (get_tags E)))))))
      (if (= NN (1- NUM))(progn
            (setq PAG_LST (append pag_lst (list TMP)))
            (setq NN -1)
            (setq TMP nil)
         )
      )                 
      (setq CNT (1+ CNT))
      (setq NN (1+ NN))
   )
   (if (/= NN 0)(progn
         (setq CNT (- (length TXT_LST) NN))
         (setq TMP nil)
         (setq NN 0)
         (while (< CNT (length TXT_LST))
            (setq TMP (append tmp (list (cons NN (nth CNT TXT_LST)))))
            (setq CNT (1+ CNT))
            (setq NN (1+ NN))        
         )
         (setq PAG_LST (append PAG_LST (list TMP)))
      )
   )
   (setq SAV PAG_LST)
   (if (= LST_NUM -1)(progn
         (set_tile "items" (itoa (length TXT_LST)))
         (next_prev PAG_LST NUM nil)
      )
   )
   (action_tile "prev" "(sav_chgs $key)(next_prev pag_lst num $key)")
   (action_tile "next" "(sav_chgs $key)(next_prev pag_lst num $key)")
   (action_tile "edit_1"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_2"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_3"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_4"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_5"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_6"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_7"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_8"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_9"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "edit_10"   "(setq ky $key)(read_val $reason $key nil)")
   (action_tile "upper" "(read_val $reason ky 1)")
   (action_tile "lower" "(read_val $reason ky 2)")
   (action_tile "accept" "(sav_chgs $key)(done_dialog)")
   (action_tile "cancel" "(term_dialog)(clean_up)")
   (start_dialog)
   (done_dialog)
   (if (= FINISH 1)(put_tags GT F_LST))
   (princ)
)
(print)
(print)
(prompt "\nDDTXT Loaded, type DDTXT to start")
(princ)
(print); end ddtxt.lsp
