; TIP1136.LSP: WIDELINE.LSP    Wide Dashed Lines    (c)1995, Watson Kilbourne

;;   Draws wide dashed line with user defined width and segment lengths
;;   in any direction.  Solid portions are twice the length of spaces.
(defun c:WIDELINE
   (/ CE BM FM OM OE SP EP DS WD LG AN NX NU LN LX P1 P2 P3 P4 P5)
   (setq CE (getvar "CMDECHO")
      BM (getvar "BLIPMODE")
      FM (getvar "FILLMODE")
      OM (getvar "OSMODE")
   )
   (defun NE (NE)
      (setvar "CMDECHO" CE)
      (setvar "BLIPMODE" BM)
      (setvar "FILLMODE" FM)
      (setvar "OSMODE" OM)
      (princ "Function cancelled")
      (princ)
   )
   (setq OE *error* *error* NE)
   (while (= SP nil) (setq SP (getpoint "\nStart of line: ")))
   (while (= EP nil) (setq EP (getpoint SP "\nNext point of line: ")))
   (setq DS (distance SP EP))
   (setq WD (getdist "\nPick or enter width of line: "))
   (if (= WD nil) (setq WD (/ DS 40)))
   (setq LG (getdist "\nPick or enter approximate length of segments: "))
   (if (= LG nil) (setq LG (* WD 3)))
   (setvar "CMDECHO" 0)
   (setvar "BLIPMODE" 0)
   (setvar "FILLMODE" 1)
   (setvar "OSMODE" 0)
   (while (not (= EP nil))
      (setq DS (distance SP EP)
         AN (angle sp ep)
         NX (/ ds lg)
         NU (fix nx)
         LN (/ ds nu)
         LX (/ ln 1.5)
         P1 sp
         P2 (polar p1 (+ AN (* pi 1.5)) (/ WD 2))
         P3 (polar p1 (+ AN (/ pi 2)) (/ WD 2))
         P4 (polar p2 AN LX)
         P5 (polar p3 AN LX)
      )
      (repeat nu
         (command ".SOLID" P2 P3 P4 P5 "")
         (setq P2 (polar P2 AN LN)
            P3 (polar P3 AN LN)
            P4 (polar P4 AN LN)
            P5 (polar P5 AN LN)
         )
      )
      (setq SP EP)
      (setq EP (getpoint sp "\nNext point: <Return or Enter to quit> "))
   )
   (setvar "CMDECHO" CE)
   (setvar "BLIPMODE" BM)
   (setvar "FILLMODE" FM)
   (setvar "OSMODE" OM)
   (setq *error* OE OE nil)
   (princ)
); end widelilne.lsp
